<?php

namespace App\Http\Controllers\Backend\Master;

use App\Models\Category;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Storage;

class AddCategoryController extends Controller
{
    public function __construct(){
        $this->middleware('auth');
    }
    public function index(){
        return view('backend.add-category');
    }

    public function createnewcategory(Request $request){
        $validatedData = $request->validate(
            [
                'cat_name' =>'required|string|max:255',
                'cat_slug' =>'required|string|max:255',

            ]
            );
        // Handle Image Upload
        $imagePath = null;
        if ($request->hasFile('cat_icon')) {
    $file = $request->file('cat_icon');
    $fileName = time().'_'.$file->getClientOriginalName();
    $destinationPath = public_path('/categories');
    $file->move($destinationPath, $fileName);
    $imagePath = 'categories/'.$fileName;
}
        
        
        // Create a new category
        $category = new Category();
        $category->cat_name = $validatedData['cat_name'];
        $category->cat_slug = $validatedData['cat_slug'];
        $category->status = $request->input('status');
        $category->cat_icon = $imagePath; // Save the image path
        $category->save();

        // Redirect with a success message
        return redirect()->back()->with('success', 'Category added successfully!');
     }

     public function edit($category_id)
     {
         $category = Category::findOrFail($category_id);
         
         return view('backend.edit-category', compact('category'));
     }

     public function update(Request $request, $category_id)
     {
         $validatedData = $request->validate(
             [
                 'cat_name' =>'required|string|max:255',
                 'cat_slug' =>'required|string|max:255',
             ]
         );
 
         // Update the category
         $category = Category::findOrFail($category_id);
         $category->cat_name = $validatedData['cat_name'];
         $category->cat_slug = $validatedData['cat_slug'];
         $category->status = $request->input('status'); // Handle the status column
         $category->save();
 
         // Redirect with a success message
         return redirect()->route('category.edit', $category_id)->with('success', 'Category updated successfully!');
     }
     public function delete($category_id)
     {
         // Delete the category
         $categorydel = Category::findOrFail($category_id);
         $categorydel->delete();
     
         // Redirect with a success message
         return redirect()->back()->with('success', 'Category deleted successfully!');
     }

      // API method to get all categories
    public function getAllCategories()
    {
        $categories = Category::all(); // Retrieve all categories from the database

        return response()->json([
            'success' => true,
            'data' => $categories
        ]);
    }
}
