<?php

namespace App\Http\Controllers\Backend\Master;

use App\Models\Category;
use Illuminate\Http\Request;
use App\Models\CreateProject;
use App\Http\Controllers\Controller;

class CreateProjectController extends Controller
{
     public function __construct(){
        $this->middleware('auth');
    }
    public function index(){
        return view('backend.create-project');
    }
    public function project_list()
    {
        $data=createproject::all();
        return view('backend/project',compact('data'));
    }

    public function project_list_category()
    {
        $data=Category::all();
        return view('backend.edit-project',compact('data'));
    }
    public function editshowcategory($projects_id){
        $data = Category::all(); // Fetch all categories
        return view('backend.edit-project', compact('data'));
    }
    public function showcategory(){
        $data=Category::all();
        return view('backend.create-project',compact('data'));
    }
//'project_name', 'project_address', 'project_state','project_city','project_pin_code','project_start_date'
    public function createproject(Request $request){
        $validatedData = $request->validate(
            [
                'project_name' =>'required|string|max:255',
                'project_category'=>'required|string|max:255',
                'project_address' =>'required|string|max:255',
                'project_state' =>'required|string|max:255',
                'project_city' =>'required|string|max:255',
                'project_pin_code' =>'required|digits:6',
                'project_start_date' =>'string|max:255',
            ]
            );
        // Create a new category
        $newProject = new CreateProject();
        $newProject->project_name = $validatedData['project_name'];
        $newProject->project_category = $validatedData['project_category'];
        $newProject->project_address = $validatedData['project_address'];
        $newProject->project_state = $validatedData['project_state'];
        $newProject->project_city = $validatedData['project_city'];
        $newProject->project_pin_code = $validatedData['project_pin_code'];
        $newProject->project_start_date = $validatedData['project_start_date'];

        $newProject->status = $request->input('status');
        $newProject->save();

        // Redirect with a success message
        return redirect()->back()->with('success', 'Category added successfully!');
     }

     public function edit($projects_id)
     {
         $project = createproject::findOrFail($projects_id);
         
         return view('backend.edit-project', compact('project'));
     }

     public function update(Request $request, $projects_id)
     {
         $validatedData = $request->validate(
             [
                'project_name' =>'required|string|max:255',
               'project_category' =>'required|string|max:255',
                'project_address' =>'required|string|max:255',
                'project_state' =>'required|string|max:255',
                'project_city' =>'required|string|max:255',
                'project_pin_code' =>'required|digits:6',
                'project_start_date' =>'string|max:255',
             ]
         );
 
         // Update the category
         $newProject = createproject::findOrFail($projects_id);
         $newProject->project_name = $validatedData['project_name'];
         $newProject->project_category = $validatedData['project_category'];
         $newProject->project_address = $validatedData['project_address'];
         $newProject->project_state = $validatedData['project_state'];
         $newProject->project_city = $validatedData['project_city'];
         $newProject->project_pin_code = $validatedData['project_pin_code'];
         $newProject->project_start_date = $validatedData['project_start_date'];
 
         $newProject->status = $request->input('status');
         $newProject->save();
 
         // Redirect with a success message
         return redirect()->route('project.edit', $projects_id)->with('success', 'updated successfully!');
     } 
     public function delete($projects_id)
     {
         $delProject = createproject::findOrFail($projects_id);
         $delProject->delete();
 
         return redirect()->back()->with('success', 'deleted successfully!');
         
     }
}
