<?php

namespace App\Http\Controllers\Backend\Master;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\CreateListing;

class ListingController extends Controller
{
     public function __construct(){
        $this->middleware('auth');
    }
    public function index(){
        
        return view('backend.listing');
    }

    public function createlisting(Request $request){
    
        $validatedData = $request->validate(
            [
                'title' => 'required|string|max:255',
                'metatitle' => 'nullable|string|max:255',
                'location' => 'nullable|string|max:255',
                'address' => 'required|string|max:255',
                'state' => 'nullable|string|max:200',
                'city' => 'required|string|max:255',
               'longitude' => 'nullable|numeric', // Valid longitude range
               'latitude' => 'nullable|numeric',    // Valid latitude range
                'price' => 'required|numeric|min:0', // Price must be a positive number
             'image.*' => 'image|mimes:jpg,png,jpeg,gif,svg|max:2048', // Example validation
              //  'amenities' => 'nullable|json', // Ensure amenities are in valid JSON format
            ]
            );

          //  dd($request);
        $crtListing = new CreateListing();
        $crtListing->title = $validatedData['title'];
        $crtListing->metatitle = $validatedData['metatitle'];
        $crtListing->location =$validatedData['location'];
        $crtListing->address = $validatedData['address'];
        $crtListing->state = $validatedData['state'];
        $crtListing->city = $validatedData['city'];
        $crtListing->longitude = $validatedData['longitude'];
        $crtListing->latitude = $validatedData['latitude'];

        $crtListing->price = $validatedData['price'];
        $crtListing->projectID = $request->input('projectID');
        $crtListing->categoryID = $request->input('categoryID');
        $crtListing->approvals = $request->input('approvals');
        $crtListing->size = $request->input('size');
        $crtListing->unit_type = $request->input('unit_type');
        $crtListing->segment = $request->input('segment');
        $crtListing->area_no = $request->input('area_no');
        $crtListing->description = $request->input('description');
        $crtListing->listing_title = $request->input('listing_title');
        $crtListing->floor_plans = $request->input('floor_plans');
        $crtListing->amenities = $request->input('amenities');

      if ($request->hasFile('image')) {
        $imagePaths = [];
        foreach ($request->file('image') as $image) {
            $originalName = pathinfo($image->getClientOriginalName(), PATHINFO_FILENAME);
            $extension = $image->getClientOriginalExtension();
            $uniqueSuffix = strtoupper(bin2hex(random_bytes(2))); // Generate a 4-letter unique suffix
            $originalName = str_replace(' ', '_', $originalName);
            $newFilename = $originalName . '_' . $uniqueSuffix . '.' . $extension;

            // Define the destination path in the public directory
            $destinationPath = public_path('/uploads');

            // Move the image to the 'public/uploads' directory
            $image->move($destinationPath, $newFilename);

            // Save the image path relative to the public directory
            $imagePaths[] = $newFilename;
        }

        // Convert the array of image paths to JSON
        $imagePathsJson = json_encode($imagePaths);
        $crtListing->image = $imagePathsJson;
    }
        $crtListing->save();

        // Redirect with a success message
        return redirect()->back()->with('success', 'Listing added successfully!');
    }

    public function showlisting(){
        $data=CreateListing::all();
        return view('backend/listing',compact('data'));
    }

    public function edit($listingID){
        $listing = CreateListing::findOrFail($listingID);
        return view('backend.edit-listing',compact('listing'));
    }

    public function update(Request $request, $listingID){
       // dd($request);
        $validatedData = $request->validate(
            [
                'title' => 'required|string|max:255',
                'metatitle' => 'nullable|string|max:255',
                'location' => 'nullable|string|max:255',
                'address' => 'required|string|max:255',
                'state' => 'nullable|string|max:200',
                'city' => 'required|string|max:255',
               'longitude' => 'nullable|numeric', // Valid longitude range
               'latitude' => 'nullable|numeric',    // Valid latitude range
                'price' => 'nullable|string|max:255', // Price must be a positive number
        
            ]
            );

          //  dd($request);
        $crtListing = CreateListing::findOrFail($listingID);
        $crtListing->title = $validatedData['title'];
        $crtListing->metatitle = $validatedData['metatitle'];
        $crtListing->location =$validatedData['location'];
        $crtListing->address = $validatedData['address'];
        $crtListing->state = $validatedData['state'];
        $crtListing->city = $validatedData['city'];
        $crtListing->longitude = $validatedData['longitude'];
        $crtListing->latitude = $validatedData['latitude'];

        $crtListing->price = $validatedData['price'];
        $crtListing->projectID = $request->input('projectID');
        $crtListing->approvals = $request->input('approvals');
        $crtListing->size = $request->input('size');
        $crtListing->unit_type = $request->input('unit_type');
        $crtListing->segment = $request->input('segment');
        $crtListing->area_no = $request->input('area_no');
        $crtListing->description = $request->input('description');
        $crtListing->listing_title = $request->input('listing_title');
        $crtListing->floor_plans = $request->input('floor_plans');
        $crtListing->amenities = $request->input('amenities');

     // Handle the image upload
    if ($request->hasFile('image')) {
        $image = $request->file('image');
        $originalName = pathinfo($image->getClientOriginalName(), PATHINFO_FILENAME);
        $extension = $image->getClientOriginalExtension();
        $uniqueSuffix = strtoupper(bin2hex(random_bytes(2))); // Generate a 4-letter unique number
        $newFilename = $originalName . '_' . $uniqueSuffix . '.' . $extension;

        // Store the image in the 'uploads' directory
        $imagePath = $image->storeAs('uploads', $newFilename, 'public');
        $crtListing->image = $imagePath; // Save the image path to the database
    }
        $crtListing->save();

        // Redirect with a success message
        return redirect()->back()->with('success', 'Listing Update successfully!');
    }

    public function delete($listingID){
        $listing = CreateListing::findOrFail($listingID);
        $listing -> delete();
        return redirect()->back()->with('success', 'Listing deleted successfully!');

    }

    public function showListingApi()
    {
        $shwoListingapi = CreateListing::all(); // Retrieve all categories from the database

    
    // Decode the 'image' field from JSON string to PHP array
    $shwoListingapi->transform(function ($listing) {
        $listing->image = json_decode($listing->image, true); // Decode JSON string to PHP array
        return $listing;
    });

    return response()->json([
        'success' => true,
        'data' => $shwoListingapi
    ]);
    }
   //show details page 
    public function showSingleListingApi($id)
    {
        $listing = CreateListing::find($id);
    
        if ($listing) {
            // Decode the 'image' field from JSON string to PHP array
            $listing->image = json_decode($listing->image, true);
    
            return response()->json([
                'success' => true,
                'data' => $listing,
            ], 200);
        } else {
            return response()->json([
                'success' => false,
                'message' => 'Listing not found',
            ], 404);
        }
    }
    
    
 //show details page 
     public function showListingbyID($categoryID)
     {
         // Retrieve all listings with the given categoryID
         $listings = CreateListing::where('categoryID', $categoryID)->get();
     
         // Decode the 'image' field from JSON string to PHP array for each listing
         $listings->transform(function ($listing) {
             $listing->image = json_decode($listing->image, true); // Decode JSON string to PHP array
             return $listing;
         });
     
         if ($listings->isNotEmpty()) {
             return response()->json([
                 'success' => true,
                 'data' => $listings,
             ], 200);
         } else {
             return response()->json([
                 'success' => false,
                 'message' => 'No listings found for this category',
             ], 404);
         }
     }
}
