<?php

namespace App\Http\Controllers\Backend\sales;

use App\Http\Controllers\Controller;
use App\Models\CreateQuery;
use Illuminate\Http\Request;


class AddQueryController extends Controller
{
    public function __construct(){
        $this->middleware('auth');
    }
    public function index(){
        return view('backend/add-query');
    }

    public function createquery(Request $request){
        
        $validatedData = $request->validate(
            [
                'sourcetype' =>'required|string|max:255',
                'name' =>'required|string|max:255',
                'email' =>'required|string|max:255',
                'phone' =>'required|string|max:255',
            ]
            );
        // Create a new category
        $newquery = new CreateQuery();
        $newquery->sourcetype = $validatedData['sourcetype'];
        $newquery->name = $validatedData['name'];
        $newquery->email = $validatedData['email'];
        $newquery->phone = $validatedData['phone'];
        $newquery->city = $request->input('city');
        $newquery->address = $request->input('address');
        $newquery->query_about = $request->input('query_about');
        $newquery->save();

        // Redirect with a success message
        return redirect()->back()->with('success', 'Category added successfully!');
    }


    // code for api 
    public function createQueryAPI(Request $request)
    {
        // Validate the incoming request data
        $validatedData = $request->validate([
            'sourcetype' => 'required|string|max:255',
            'name' => 'required|string|max:255',
            'email' => 'required|string|max:255',
            'phone' => 'required|string|max:255',
            // Add validation for optional fields if necessary
            'city' => 'nullable|string|max:255',
            'address' => 'nullable|string|max:255',
            'query_about' => 'nullable|string|max:1000',
        ]);
    
        // Create a new query instance
        $newQuery = new CreateQuery();
        $newQuery->sourcetype = $validatedData['sourcetype'];
        $newQuery->name = $validatedData['name'];
        $newQuery->email = $validatedData['email'];
        $newQuery->phone = $validatedData['phone'];
        $newQuery->city = $request->input('city');
        $newQuery->address = $request->input('address');
        $newQuery->query_about = $request->input('query_about');
        $newQuery->save();
    
        // Return a JSON response indicating success
        return response()->json([
            'success' => true,
            'message' => 'Query added successfully!',
            'data' => $newQuery
        ], 201);
    }
    

    public function showquery(){
        $data=CreateQuery::all();
        //dd($data);
        return view('backend.query',compact('data'));
    }



    public function edit($query_detailsID)
    {
        $query = CreateQuery::findOrFail($query_detailsID);
     
        return view('backend.query', compact('query'));
    }
    public function update($query_detailsID, $status)
    {
        // Find the query by ID
        $query = CreateQuery::find($query_detailsID);

        if ($query) {
            // Update the status
            $query->status = $status;
            $query->save();

            // Redirect with a success message
            return redirect()->back()->with('success', 'Status updated successfully.');
        }

        // Redirect with an error message if the query is not found
        return redirect()->back()->with('error', 'Query not found.');
    }


    public function showquerybyApi()
    {
        $showQuery = CreateQuery::all(); // Retrieve all categories from the database

        return response()->json([
            'success' => true,
            'data' => $showQuery
        ]);
    }
}
